/*
 * dsp_handling.h
 *
 *  Created on: 8. jan. 2022
 *      Author: oyvindteig
 */


#ifndef DSP_HANDLING_H_
#define DSP_HANDLING_H_

    #define DSP_COMPLEX_N_SIZE (1 << DSP_COMPLEX_N_SIZE_LOG2)

    typedef struct {
        unsigned     num_samples; // The number of valid samples
        mic_sample_t samples [DSP_COMPLEX_N_SIZE];
        bool         is_full;
        unsigned     num_lost_overflowed;
        bool         was_late;
    } mic_samples_dsp_t;

    typedef bool get_next_mic_samples_buffer_t;



    // https://www.teigfam.net/oyvind/home/technology/219-my-beep-brrr-notes/#Ref16
    // NUM_SAMPLES SAMPLING_FREQ_HZ FRAME_LENGTH_MS NUM_FFT_FREQ_BINS HZ_PER_BIN
    // 8192         8000            1024            4096              1.95
    // 8192        12000            682.666..       4096              2.92
    // 4096         8000            512             2048              3.91
    // 4096        12000            341.333..       2048              5.86
    // 2048         8000            256             1024              7.81
    // 2048        12000            170.666..       1024             11.72

    void dsp_task_y (chanend ch_out_in);

    void buffer_task_x (
            chanend ch_in,     // data_ch_phase0_t  then data_ch_phase3_t
            chanend ch_in_out); // mic_samples_dsp_t then get_next_mic_samples_buffer_t

#else
    #error NESTED .h FILE
#endif
